<div class="test-details__main">
    <div class="page-wrapper">
        <div class="page test-details">
            <zeb-page-header
                breadcrumb-custom-actions="$ctrl.breadcrumbsCustomActions"
                page-title="$ctrl.currentTitle">
            </zeb-page-header>
            <div class="p-tests-run-details__sticky-header test-details__header">
                <test-run-card is-notification-available="$ctrl.isNotificationAvailable"
                    test-run="$ctrl.testRun"
                    on-smart-analysis-run="$ctrl.updateFailureTagAssignments()"
                    single-mode="true"></test-run-card>
                <div ng-hide="!$ctrl.testRun.tests"
                    class="test-details__header-actions-wrapper"
                    ng-if="!$ctrl.isMobile">
                    <div class="test-run-group-row test-details__header-actions _default">
                        <div class="sort-new test-run-group-column">
                            <div class="test-run-group">
                                <div class="test-details__test-selection _all" flex="none" ng-if="$ctrl.canManageTestRuns">
                                    <md-checkbox name="testCheckbox"
                                        class="test-details__test-checkbox"
                                        aria-label="Select"
                                        ng-checked="$ctrl.hasSelectedTests && !$ctrl.hasUnselectedTests"
                                        md-indeterminate="$ctrl.hasSelectedTests && $ctrl.hasUnselectedTests"
                                        ng-click="$ctrl.onAllTestsSelect()"
                                        ng-disabled="!$ctrl.testsToDisplay.length && $ctrl.testsViewMode === 'plain'"
                                        ng-true-value="true"
                                        ng-false-value="false">
                                    </md-checkbox>
                                </div>
                                <div class="test-run-group_wrapper _left">
                                    <md-input-container class="test-details__search _with-icon _without-animation">
                                        <label class="placeholder-label">Search items</label>
                                        <input ng-model-options="{debounce: 700}"
                                            type="text"
                                            ng-model="$ctrl.searchCriteria"
                                            ng-change="$ctrl.onSearch()"
                                            aria-label="Search items"
                                            aria-describedby="basic-addon2">
                                        <i class="material-icons">
                                            search
                                        </i>
                                    </md-input-container>
                                    <md-input-container class="test-details__select select-wrapper no-padding without-animation">
                                        <md-select id="viewModeSelect"
                                            ng-model="$ctrl.testsViewMode"
                                            md-selected-html="$ctrl.getSelectedGroupText()"
                                            class="form-fields__select"
                                            name="viewModeSelect"
                                            ng-change="$ctrl.onViewModeSelect()"
                                            placeholder="Group by">
                                            <md-option md-ink-ripple="0"
                                                ng-repeat="groupingOption in $ctrl.groupingOptions track by groupingOption.value"
                                                ng-value="groupingOption.value"
                                                ng-if="groupingOption.isDefault || !$ctrl.groupingFilters[groupingOption.value].isEmptyGroupData"
                                                ng-selected="groupingOption.value === $ctrl.testsViewMode">{{ groupingOption.name }}</md-option>
                                        </md-select>
                                    </md-input-container>
                                    <md-input-container class="test-details__select select-wrapper no-padding without-animation">
                                        <md-select id="sortSelect"
                                            ng-model="$ctrl.selectedOrder"
                                            ng-model-options="{trackBy: '$value.name'}"
                                            md-selected-html="$ctrl.getSelectedOrderText()"
                                            class="form-fields__select"
                                            name="sortSelect"
                                            ng-change="$ctrl.onOrderChange()"
                                            placeholder="Sort by">
                                            <md-option md-ink-ripple="0"
                                                ng-repeat="sortOption in $ctrl.sortOptions track by sortOption.name"
                                                ng-value="sortOption"
                                                ng-selected="sortOption === $ctrl.selectedOrder">{{ sortOption.name }}</md-option>
                                        </md-select>
                                    </md-input-container>
                                </div>
                                <div class="test-run-group_wrapper _right">
                                    <status-buttons on-button-click="$ctrl.filterByStatus($statuses)"
                                        ng-if="!$ctrl.isTablet"
                                        initial-selections="$ctrl.filters.status.values"></status-buttons>
                                    <div class="test-run-group_other-buttons">
                                        <md-button id="resetAllToggle"
                                            class="md-raised"
                                            ng-disabled="!$ctrl.isStatusFilteringActive && !$ctrl.isSortingActive && !$ctrl.searchCriteria && $ctrl.testsViewMode === 'plain'"
                                            type="button"
                                            ng-click="$ctrl.resetStatusFilterAndOrdering();">
                                            RESET
                                        </md-button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="test-details__header-actions _bulk"
                        layout="row"
                        layout-align="start center"
                        ng-if="!$ctrl.isTablet && ($ctrl.hasSelectedTests || $ctrl.hasSelectedGroups)">
                        <div class="test-details__test-selection _all _bulk" flex="none">
                            <md-checkbox name="testCheckbox"
                                class="test-details__test-checkbox"
                                aria-label="Select"
                                ng-checked="$ctrl.hasSelectedTests && !$ctrl.hasUnselectedTests"
                                md-indeterminate="$ctrl.hasSelectedTests && $ctrl.hasUnselectedTests"
                                ng-click="$ctrl.onAllTestsSelect()"
                                ng-disabled="!$ctrl.testsToDisplay.length && $ctrl.testsViewMode === 'plain'"
                                ng-true-value="true"
                                ng-false-value="false">
                                <span class="test-details__test-checkbox-label">{{$ctrl.selectedTestsCount}}/{{$ctrl.testsCount}} selected</span>
                            </md-checkbox>
                        </div>
                        <div flex="auto" layout="row" class="test-details__header-actions-btns">
                            <md-button
                                ng-repeat="btn in $ctrl.batchButtons"
                                ng-disabled="btn.disabled"
                                flex="none"
                                class="{{ btn.class }}"
                                ng-class="{ '_completed': btn.completed }"
                                ng-click="btn.onClick($event, btn)">
                                <md-icon ng-if="btn.mdIcon">{{ btn.mdIcon }}</md-icon>
                                <span class="btn-icon" ng-if="!btn.mdIcon"></span>
                                <span class="btn-txt">{{ btn.completed ? btn.altText: btn.text }}</span>
                            </md-button>
                        </div>
                        <md-button id="close"
                            flex="none"
                            class="md-icon-button _default-md-style"
                            ng-click="$ctrl.onBulkClose()">
                            <md-icon aria-label="Reset selection">close</md-icon>
                        </md-button>
                    </div>
                </div>
            </div>
            <md-fab-speed-dial id="main-fab"
                ng-if="$ctrl.canManageTestRuns && $ctrl.isTablet && !$ctrl.testsLoading && !$ctrl.scrollTicking"
                md-direction="up"
                class="md-scale md-fab-bottom-right">
                <md-fab-trigger>
                    <md-button id="mainFab"
                        aria-label="menu"
                        class="md-fab md-primary"
                        md-visible="tooltipVisible"
                        ng-click="$ctrl.showFilterDialog($event)">
                        <div class="search-fab"
                            ng-class="{'_list': !$ctrl.isStatusFilteringActive, '_checked-list': $ctrl.isStatusFilteringActive || $ctrl.isMobileSearchActive}"
                            aria-hidden="true"></div>
                    </md-button>
                </md-fab-trigger>
            </md-fab-speed-dial>
            <md-fab-speed-dial id="bulk-fab"
                ng-if="$ctrl.isTablet && ($ctrl.hasSelectedTests || hasSelectedGroups) && !$ctrl.scrollTicking"
                md-direction="up"
                class="md-scale md-fab-bottom-right">
                <md-fab-trigger>
                    <md-button id="bulkFab"
                        aria-label="menu"
                        class="md-fab md-primary"
                        md-visible="tooltipVisible">
                        <span class="fa fa-bars" aria-hidden="true"></span>
                    </md-button>
                </md-fab-trigger>
                <md-fab-actions>
                    <md-button
                        aria-label="menu"
                        ng-repeat="fabBtn in $ctrl.batchButtons"
                        ng-if="!fabBtn.disabled"
                        class="md-fab md-raised md-fab-sm {{ fabBtn.class }}"
                        ng-click="fabBtn.onClick($event, fabBtn)">
                        <md-tooltip md-direction="top">{{ fabBtn.text }}</md-tooltip>
                        <span class="fa {{ fabBtn.mobileIconClass }}" aria-hidden="true"></span>
                    </md-button>
                </md-fab-actions>
            </md-fab-speed-dial>
            <article class="article ui-section">
                <div class="test-details__labels-controllers" ng-if="!$ctrl.isMobile">
                    <div class="test-label">
                        <div class="test-label__item button no-animate" ng-class="{'_disabled': $ctrl.isTestLoading || $ctrl.expandAllLabelsFlag || $ctrl.showLabelsControls <= 5}" ng-click="$ctrl.handleAllLabelsExpand(true)">
                            <span class="test-label__item-value"><md-icon class="test-label__button-icon">chevron_right</md-icon>Expand all labels</span>
                        </div>
                        <div class="test-label__item button no-animate" ng-class="{'_disabled': $ctrl.isTestLoading || !$ctrl.expandAllLabelsFlag || $ctrl.showLabelsControls <= 5}" ng-click="$ctrl.handleAllLabelsExpand(false)">
                            <span class="test-label__item-value"><md-icon class="test-label__button-icon">chevron_left</md-icon>Collapse all labels</span>
                        </div>
                    </div>
                </div>
                <md-card ng-class="{'empty': $ctrl.empty}">
                    <div class="test-details__table">
                        <div ng-repeat-start="filterGroup in $ctrl.groupingFilters[$ctrl.testsViewMode].groupData track by filterGroup.name"
                            ng-if="$ctrl.testsViewMode !== 'plain'"
                            class="test-details__table-row _groups">
                            <div class="test-details__table-col _checkbox">
                                <div class="test-details__test-selection _group" flex="none">
                                    <md-checkbox name="groupCheckbox"
                                        class="test-details__test-checkbox _group"
                                        aria-label="Select"
                                        ng-checked="$ctrl.groupHasSelectedTests(filterGroup) && !$ctrl.groupHasUnselectedTests(filterGroup)"
                                        md-indeterminate="$ctrl.groupHasSelectedTests(filterGroup) && $ctrl.groupHasUnselectedTests(filterGroup)"
                                        ng-click="$ctrl.onGroupSelect(filterGroup)"
                                        ng-disabled="false"
                                        ng-true-value="true"
                                        ng-false-value="false">
                                    </md-checkbox>
                                </div>
                            </div>
                            <div class="test-details__table-col _group-name" ng-click="$ctrl.toggleGroupingFilter(filterGroup);">
                                <div class="test-details__group-header">
                                    <i class="test-details__group-collapse-icon material-icons"
                                        ng-class="$ctrl.activeGroupingFilter === filterGroup ? 'checked' : 'unchecked'">
                                        keyboard_arrow_down
                                    </i>
                                    <span class="test-details__group-name">{{ filterGroup.label }}</span>
                                    <span class="test-details__group-count">{{ filterGroup.count }}</span>
                                </div>
                            </div>
                        </div>
                        <div ng-if="$ctrl.activeTests.length && $ctrl.activeTests.length > $ctrl.countPerPage && ($ctrl.testsViewMode === 'plain' || $ctrl.activeGroupingFilter === filterGroup)"
                            class="test-details__table-row _pagination _top">
                            <div class="test-details__table-col">
                                <md-table-pagination
                                    id="pagination"
                                    zafira-background-theme="pagination"
                                    md-limit="$ctrl.countPerPage"
                                    md-limit-options="$ctrl.limitOptions"
                                    md-label="{rowsPerPage: 'Items per page:'}"
                                    md-page="$ctrl.currentPage"
                                    md-total="{{$ctrl.activeTests.length}}"
                                    md-page-select=false
                                    md-boundary-links=true
                                    md-on-paginate="$ctrl.onPageChange"></md-table-pagination>
                            </div>
                        </div>
                        <div ng-if="$ctrl.testsToDisplay.length && ($ctrl.testsViewMode === 'plain' || $ctrl.activeGroupingFilter === filterGroup)"
                            class="test-details__table-row _tests">
                            <div class="test-details__table-col">
                                <test-card test="testItem"
                                    ng-if="$ctrl.testsToDisplay.length"
                                    failure-tags="$ctrl.failureTags"
                                    on-change-test-status="$ctrl.changeTestStatus($data)"
                                    on-open-images-viewer-modal="$ctrl.openImagesViewerModal($data)"
                                    on-show-details-dialog="$ctrl.showDetailsDialog($data)"
                                    on-set-failure-tag="$ctrl.setFailureTag($data)"
                                    on-test-info-go="$ctrl.goToTestDetails($testId)"
                                    on-test-select="$ctrl.onTestSelect($test)"
                                    on-test-sessions-open="$ctrl.openSessionsSidenav($test)"
                                    qtest-integration="$ctrl.qtestIntegration"
                                    jira-integration="$ctrl.jiraIntegration"
                                    testrail-integration="$ctrl.testrailIntegration"
                                    highlighted-test-id="$ctrl.testId"
                                    is-integration-initialized="$ctrl.isIntegrationInitialized"
                                    ng-repeat="testItem in $ctrl.testsToDisplay track by testItem.id"></test-card>
                            </div>
                        </div>
                        <div name="testLoading" class="test-details__table-row _empty _loading" ng-if="$ctrl.testsLoading">
                            <div class="test-details__table-col">
                                <span>
                                    <md-progress-circular md-mode="indeterminate" md-diameter="20px" class="tests-loading-spinner"></md-progress-circular>
                                    Tests are loading...
                                </span>
                            </div>
                        </div>
                        <div  class="test-details__table-row _empty _filtering"
                            ng-if="!$ctrl.testsLoading && !$ctrl.testsToDisplay.length && $ctrl.getEmptyTestsMessage(filterGroup)">
                            <div class="test-details__table-col">{{$ctrl.getEmptyTestsMessage(filterGroup)}}</div>
                        </div>
                        <div ng-repeat-end
                            ng-if="$ctrl.activeTests.length && $ctrl.activeTests.length > $ctrl.countPerPage && ($ctrl.testsViewMode === 'plain' || $ctrl.activeGroupingFilter === filterGroup)"
                            class="test-details__table-row _pagination _bottom">
                            <div class="test-details__table-col">
                                <md-table-pagination
                                    id="footer-pagination"
                                    zafira-background-theme="pagination"
                                    md-limit="$ctrl.countPerPage"
                                    md-page="$ctrl.currentPage"
                                    md-total="{{$ctrl.activeTests.length}}"
                                    md-page-select=false
                                    md-boundary-links=true
                                    md-on-paginate="$ctrl.onPageChange"></md-table-pagination>
                            </div>
                        </div>
                    </div>
                </md-card>
            </article>
        </div>
    </div>
    <md-sidenav class="md-sidenav-right test-sessions-sidenav"
        md-swipe-right="$ctrl.onSidenavSwipeRight($event, $target)"
        md-component-id="test-sessions-sidenav"
        md-whiteframe="1">
        <div class="test-sessions-sidenav__header">
            <h2 class="test-sessions-sidenav__title">Sessions: <b>{{$ctrl.sessionsInfoActiveTest.name}}</b></h2>
            <md-button class="md-sidenav-right__close md-icon-button _default-md-style"
                ng-click="$ctrl.closeSessionsSidenav()">
                <md-icon class="md-sidenav-right__close-icon" aria-label="Close sidenav">close</md-icon>
            </md-button>
        </div>
        <test-sessions test="$ctrl.sessionsInfoActiveTest"></test-sessions>
    </md-sidenav>
</div>
